package com.s5gi.hud;

import com.mojang.blaze3d.systems.RenderSystem;
import com.s5gi.networking.payloads.S2C.HudRendererTimeUpdatePayload;
import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.gui.DrawContext;
import net.minecraft.client.render.*;
import net.minecraft.util.Identifier;

import java.util.function.Function;

import static com.s5gi.Lacess.MOD_ID;

public class HudRenderer {

    public static void handleHudRendererTimeUpdateNetworking(HudRendererTimeUpdatePayload payload, ClientPlayNetworking.Context context) {
        context.client().execute(() -> {
            if (payload.var().contains("1")) {
                TestDustOverlay.startTime = System.currentTimeMillis();
            }
        });
    }

    public static void drawHud(DrawContext context, RenderTickCounter counter) {
        TestDustOverlay.drawTestDustHudOverlay(context, counter);
    }



    private class TestDustOverlay {
        private static final int DISPLAY_DURATION = 2000;
        private static Identifier image_id = Identifier.of(MOD_ID, "textures/gui/test_dust_overlay.png");


        private static long startTime = -1;
        private static long lastTime = -1;
        private static void drawTestDustHudOverlay(DrawContext context, RenderTickCounter counter) {
            if (startTime >= 0) {
                long currentTime = System.currentTimeMillis();
                long elapsedTime = currentTime - startTime;

                if (elapsedTime >= DISPLAY_DURATION) {
                    startTime = -1; // Reset startTime to stop rendering
                    return;
                }

                MinecraftClient client = MinecraftClient.getInstance();
                int screenWidth = client.getWindow().getScaledWidth();
                int screenHeight = client.getWindow().getScaledHeight();

                float opacity = 1.0f - (float) elapsedTime / DISPLAY_DURATION;
                RenderSystem.setShaderTexture(0, image_id);
                RenderSystem.enableBlend();
                RenderSystem.defaultBlendFunc();
                RenderSystem.setShaderColor(1f, 1f, 1f, opacity);
                //stupidest shit known to man kind
                context.drawTexture(RenderLayer::getGuiTextured, image_id, 0, 0, 0, 0, screenWidth, screenHeight, screenWidth, screenHeight);
                //end of stupidest shit known ato man kind
                RenderSystem.disableBlend();

            }
        }
    }
}
